#!"C:\xampp\perl\bin\perl.exe" -w
#
# Copyright (C) Joseph Heenan 2005
#

my $controller = "--scontroller COM1"; # use a serial Dusky controller on this COM port
my $skyplus = 1; # set to 1 if skyplus box, 0 for normal sky box
my $delay = 1; # number of seconds to sleep to allow sky box to process command

BEGIN
{
    use CGI::Carp qw(fatalsToBrowser warningsToBrowser carpout);
    # disable buffering on stdout, so any stderr output will occur after
    # the Content-Type output
    $| = 1;
    print "Content-Type: text/html\r\n\r\n";
    carpout(STDOUT);
    warningsToBrowser(1);
}

use strict;
use CGI qw(:standard);

exit main();

sub sendaction
{
    my $code;
    my %codes;
    
    my $action = param("cmd");
    my $channel = param("channel");
    my $outputnum = param("output");
    $outputnum = 1 if (!defined($outputnum));
    
    undef $channel if (defined($channel) && $channel eq "");
    undef $action if (defined($action) && $action eq "");

    return if (!defined($channel) && !defined($action));
    
    if ($skyplus)
    {
        %codes = (
            "0" => 0x0c00,
            "1" => 0x0c01,
            "2" => 0x0c02,
            "3" => 0x0c03,
            "4" => 0x0c04,
            "5" => 0x0c05,
            "6" => 0x0c06,
            "7" => 0x0c07,
            "8" => 0x0c08,
            "9" => 0x0c09,
            "red" => 0x0c6d,
            "green" => 0x0c6e,
            "blue" => 0x0c70,
            "yellow" => 0x0c6f,
            "rewind" => 0x0c3d,
            "record" => 0x0c40,
            "stop" => 0x0c3f,
            "fast forward" => 0x0c28,
            "play" => 0x0c3e,
            "pause" => 0x0c24,
            "text" => 0x0c3c,
            "back up" => 0x0c83,
            "help" => 0x0c81,
            "up" => 0x0c58,
            "down" => 0x0c59,
            "left" => 0x0c5a,
            "right" => 0x0c5b,
            "select" => 0x0c5c,
            "ch+" => 0x0c20,
            "ch-" => 0x0c21,
            "info" => 0x0ccb,
            "tv guide" => 0x0ccc,
            "box office" => 0x0c7d,
            "services" => 0x0c7e,
            "interactive" => 0x0cf5,
            "sky" => 0x0c80,
            "power" => 0x0c0c,
            "key_esc" => 0x028d,
            "key_minus" => 0x02dd,
            "key_equals" => 0x02df,
            "key_backspace" => 0x0290,
            "key_del" => 0x0289,
            "key_tab" => 0x028e,
            "key_q" => 0x02a6,
            "key_w" => 0x02ac,
            "key_e" => 0x029a,
            "key_r" => 0x02a7,
            "key_t" => 0x02a9,
            "key_y" => 0x02ae,
            "key_u" => 0x02aa,
            "key_i" => 0x029e,
            "key_o" => 0x02a4,
            "key_p" => 0x02a5,
            "key_openbracket" => 0x02da,
            "key_closebracket" => 0x02db,
            "key_a" => 0x0296,
            "key_s" => 0x02a8,
            "key_d" => 0x0299,
            "key_f" => 0x029b,
            "key_g" => 0x029c,
            "key_h" => 0x029d,
            "key_j" => 0x029f,
            "key_k" => 0x02a0,
            "key_l" => 0x02a1,
            "key_semicolon" => 0x02e5,
            "key_return" => 0x028f,
            "key_z" => 0x02af,
            "key_x" => 0x02ad,
            "key_c" => 0x0298,
            "key_v" => 0x02ab,
            "key_b" => 0x0297,
            "key_n" => 0x02a3,
            "key_m" => 0x02a2,
            "key_comma" => 0x02ec,
            "key_dot" => 0x02ed,
            "key_apostrophe" => 0x02e7,
            "key_hash" => 0x02e9,
            "key_space" => 0x0291,
            "key_at" => 0x02e6,
            "key_backslash" => 0x02f0,
            "key_pagedown" => 0x028c,
            "key_home" => 0x0288,
            "key_bang" => 0x02d2,
            "key_euro" => 0x02d1,
            "key_pound" => 0x02d4,
            "key_dollar" => 0x02d5,
            "key_percent" => 0x02d6,
            "key_caret" => 0x02d7,
            "key_ampersand" => 0x02d8,
            "key_asterisk" => 0x02d9,
            "key_leftsquarebracket" => 0x02e2,
            "key_rightsquarebracket" => 0x02e3,
            "key_underscore" => 0x02dc,
            "key_plus" => 0x02de,
            "key_leftcurleybracket" => 0x02e0,
            "key_rightcurleybracket" => 0x02e1,
            "key_colon" => 0x02e4,
            "key_lessthan" => 0x02ea,
            "key_greaterthan" => 0x02eb,
            "key_quote" => 0x02d3,
            "key_tilde" => 0x02e8,
            "key_questionmark" => 0x02ee,
            "key_slash" => 0x02ef,
            "key_pageup" => 0x028b,
            "key_end" => 0x028a,
            "key_upperq" => 0x02c0,
            "key_upperw" => 0x02c6,
            "key_uppere" => 0x02b4,
            "key_upperr" => 0x02c1,
            "key_uppert" => 0x02c3,
            "key_uppery" => 0x02c8,
            "key_upperu" => 0x02c4,
            "key_upperi" => 0x02b8,
            "key_uppero" => 0x02be,
            "key_upperp" => 0x02bf,
            "key_uppera" => 0x02b0,
            "key_uppers" => 0x02c2,
            "key_upperd" => 0x02b3,
            "key_upperf" => 0x02b5,
            "key_upperg" => 0x02b6,
            "key_upperh" => 0x02b7,
            "key_upperj" => 0x02b9,
            "key_upperk" => 0x02ba,
            "key_upperl" => 0x02bb,
            "key_upperz" => 0x02c9,
            "key_upperx" => 0x02c7,
            "key_upperc" => 0x02b2,
            "key_upperv" => 0x02c5,
            "key_upperb" => 0x02b1,
            "key_uppern" => 0x02bd,
            "key_upperm" => 0x02bc,
            "key_1" => 0x02f7,
            "key_2" => 0x02f8,
            "key_3" => 0x02f9,
            "key_4" => 0x02fa,
            "key_5" => 0x02fb,
            "key_6" => 0x02fc,
            "key_7" => 0x02fd,
            "key_8" => 0x02fe,
            "key_9" => 0x02ff,
            "key_0" => 0x02f6,
            "key_ch+" => 0x0220,
            "key_ch-" => 0x0221,
            "key_info" => 0x0264,
            "tv" => 0x0c84,
            "key_power" => 0x020c,
            "key_sky" => 0x0280,
            "key_tv" => 0x0284,
            "key_up" => 0x025f,
            "key_down" => 0x0260,
            "key_left" => 0x025d,
            "key_right" => 0x025e,
            "key_select" => 0x0261,
            "key_text" => 0x0263,
            "key_help" => 0x0262,
            "key_red" => 0x0266,
            "key_green" => 0x0267,
            "key_yellow" => 0x0268,
            "key_blue" => 0x0268,
            "key_back up" => 0x0265,
            "key_interactive" => 0x02f5,
            "key_tvguide" => 0x02cc
        );
    }
    else
    {
        %codes = (
            "up" => 0x0058,
            "down" => 0x0059,
            "left" => 0x005A,
            "right" => 0x005B,
            "sky" => 0x0080,
            "power" => 0x000c,
            "ch+" => 0x0020,
            "ch-" => 0x0021,
            "text" => 0x003c,
            "select" => 0x005c,
            "help" => 0x0081,
            "back up" => 0x0083,
            "red" => 0x006d,
            "green" => 0x006e,
            "yellow" => 0x006f,
            "blue" => 0x0070,
            "tv guide" => 0x00cc,
            "box office" => 0x007d,
            "services" => 0x007e,
            "interactive" => 0x00f5,
            "info" => 0x00cb,
            "0" => 0x0000,
            "1" => 0x0001,
            "2" => 0x0002,
            "3" => 0x0003,
            "4" => 0x0004,
            "5" => 0x0005,
            "6" => 0x0006,
            "7" => 0x0007,
            "8" => 0x0008,
            "9" => 0x0009
        );
    }
    
    my $type = $skyplus ? "--sky+" : "--sky";
    my $cmd;
    if (defined($channel))
    {
        # channel number
        $cmd = sprintf("sky-control.exe %s --output %d %s --channel %d",
                        $controller, $outputnum, $type, $channel);
    }
    else
    {
        # normal command
        $code = $codes{$action};
        die "undefined action $action" if (!defined($code));
        $cmd = sprintf("sky-control.exe %s --output %d %04x",$controller,$outputnum, $code);
    }
    #print $cmd;
    my $output = `$cmd`;
    my $ret = $?;
    if ($ret != 0)
    {
        $output = "" if (!defined($output));
        die "Can't run '$cmd' ($! - $ret): $output";
    }
}

sub main
{
    $ENV{PATH} = "/usr/local/bin:/usr/bin:/bin";

    sendaction();

    sleep $delay;

    my $outputnum = param("output");
    $outputnum = 1 if (!defined($outputnum));
    my $replace="SELECTED".$outputnum."X";

    my $uniq = int(rand(10000));
    open(FH, "controls.html") or die "Unable to read controls.html";
    while (<FH>)
    {
        s/UNIQ/$uniq/;
        s/$replace/selected/;
        s/SELECTED.*X//;
        print;
    }
    close(FH);

}
